/*
 * auto_reply - This is the program used by protector to send a reply back
 *		to the sender of an e-mail, to inform him/her that the mail
 *		hasnt got through in it's entirety.
 *
 * Copyright (c) Christopher M. R. Lowth - chris@lowth.com
 * Written by Christopher M. R. Lowth
 *
 * Permission is granted to anyone to use this software for any purpose on
 * any computer system, and to alter it and redistribute it freely, subject
 * to the following restrictions:
 *
 * 1. The author is not responsible for the consequences of use of this
 *    software, no matter how awful, even if they arise from flaws in it.
 *
 * 2. The origin of this software must not be misrepresented, either by
 *    explicit claim or by omission.  Since few users ever read sources,
 *    credits must appear in the documentation.
 *
 * 3. Altered versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.  Since few users
 *    ever read sources, credits must appear in the documentation.
 *
 * 4. This notice may not be removed or altered.
 */




/* NB : THIS IS HIGHLY INCOMPLETE - DONT USE IT !! */




#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdarg.h>

#include "protector.h"
#include "proto.h"

int local_errno;
int page_width = 65;

char paragraph[4096];

void wrap(char *fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
	vsprintf(paragraph + strlen(paragraph), fmt, ap);
	strcat(paragraph, " ");
	va_end(ap);
}

void new_paragraph(int gap)
{
	char *p;
	int w, i;

	w = 0;	
	for (p = strtok(paragraph, " "); p != NULL; p = strtok(NULL, " ")) {
		if (strlen(p) + w > page_width) {
			printf("\n%s", p);
			w = strlen(p);
		}
		else {
			printf("%s%s", p == paragraph ? "" : " ", p);
			w += strlen(p) + 1;
		}
	}
	printf("\n");
	for (i=0; i<gap; i++) printf("\n");
	memset(paragraph, 0, sizeof(paragraph));
}

void trim_one_char()
{
	int len = strlen(paragraph);
	if (len > 0)
		len --;
	paragraph[len] = '\0';
}

int main(int argc, char *argv[])
{
	char *msg_file = argv[1];
	int protector_status = atoi(argv[2]);
	int procmail_status = atoi(argv[3]);
	mailrec_t mailrec;
	FILE *source = fopen(msg_file, "r");
	char *sender, *subject, *date, *recipient;

	memset(&mailrec, 0, sizeof(mailrec_t));

	mailrec.file = source;
	mailrec.start_header = ftell(source);

	if (!read_headers(source, &mailrec))
		return 2;

	mailrec.start_body = ftell(source);

	fclose(source); source = NULL;

	sender    = get_sender(&mailrec);
	subject   = get_header(&mailrec, "subject", 1);
	date      = get_header(&mailrec, "date", 1);
	recipient = get_recipient(&mailrec);

	printf("MAIL TO : %s\n", sender);
	printf("From: %s\n", recipient);
	printf("Subject: RE: %s\n", subject);
	printf("\n");

	wrap("This warning message has been automatically generated by our");
	wrap("e-mail delivery software. It has not been sent to you by a");
	wrap("human being.");
	new_paragraph(3);

	if (date != NULL)
		wrap("At %s, you", date);
	else
		wrap("You");
	wrap("sent an e-mail message");
	if (recipient != NULL)
		wrap("to %s", recipient);
	if (subject != NULL)
		wrap("with the subject of '%s'", subject);
	trim_one_char();
	wrap(".");
	new_paragraph(2);

	wrap("The message contained an attachment that our e-mail system");
	wrap("believes to be dangerous. This may be because it contains a");
	wrap("file that could (in theory) contain a virus, who's type");
	wrap("could not be determined reliably, or that could not be checked");
	wrap("for virus (or other dangerous) content for some reason.");
	new_paragraph(1);

	wrap("Our e-mail system has delivered the message to the person you sent");
	wrap("it to, but has removed the possibly contaminated attachment");
	wrap("first. This means that the attachment has not 'got through'.");
	new_paragraph(1);

	wrap("If you sent us a Microsoft office document (word, excel or");
	wrap("powerpoint) and you wish to try again; please ensure that it");
	wrap("does not contain ANY macros (our e-mail system rejects all MS");
	wrap("Office files that contain them, since they are a major source");
	wrap("of virus contamination), and try to send it to us in 'RTF' or");
	wrap("'Rich Text Format'. This can usually be achieve by using the");
	wrap("'Save As' option in the 'File' menu of your program, and");
	wrap("selecting 'RTF' or 'Rich Text' in the 'Type' or 'Format' box.");
	new_paragraph(1);

	wrap("We appologise for the inconvenience this may cause you, but");
	wrap("are grateful for your co-operation in keeping our office a");
	wrap("virus-free zone.");
	new_paragraph(1);

	wrap("Thank you.");
	new_paragraph(1);


	return 0;
}
