/*
 * main - the "main" procedure of the "protector" program.
 *
 * Copyright (c) Christopher M. R. Lowth - chris@lowth.com
 * Written by Christopher M. R. Lowth
 *
 * Permission is granted to anyone to use this software for any purpose on
 * any computer system, and to alter it and redistribute it freely, subject
 * to the following restrictions:
 *
 * 1. The author is not responsible for the consequences of use of this
 *    software, no matter how awful, even if they arise from flaws in it.
 *
 * 2. The origin of this software must not be misrepresented, either by
 *    explicit claim or by omission.  Since few users ever read sources,
 *    credits must appear in the documentation.
 *
 * 3. Altered versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.  Since few users
 *    ever read sources, credits must appear in the documentation.
 *
 * 4. This notice may not be removed or altered.
 */

#include <stdio.h>
#include <assert.h>

#include "protector.h"
#include "proto.h"

int local_errno;

int main(int argc, char *argv[])
{
	FILE *id;
	mailrec_t *mailrec;

	if (argc < 2) {
		printf("\n");
		printf("Protector     : Version " VERSION "\n");
		printf("Copyright     : Chris Lowth - chris@lowth.com\n");
		printf("License terms : GNU General Public License version 2 (June 1991)\n");
		printf("\n");
		return 1;
	}
	id = fopen(argv[1], "r");
	assert(id != NULL);
	mailrec = read_mailrec(id, NULL, 0);
	assert(mailrec != NULL);
	return write_mailrec(stdout, mailrec, TRUE);
	/* dump_mailrec(mailrec, 0); */
	return 0;
}
